var ssMetaData = null;

function ssMetaDataLoad() 
{
  ssMetaData = new ssMetaDataManager();
  ssMetaData.init();
}

function ssMetaDataUnload()
{
  ssMetaData.destroy();
  ssMetaData = null;
}

function ssMetaDataManager()
{
  return this;
}

ssMetaDataManager.prototype =
{
  init: function()
  {
  	var vbox = document.getElementById( "searchstatus-metadata-details" );
  	var listbox = document.getElementById( "searchstatus-metadata-listbox" );
  	var noItems = true;

  	var topWindow = getTopWindow();
  	var titles = topWindow._content.document.getElementsByTagName( "title" );
  	if( titles.length > 0 )
  	{
  		var title = titles.item( 0 );
  		
  		if( title.hasChildNodes() )
  		{
				var richlistitem = document.createElement( "richlistitem" );
				var name = document.createElement( "description" );
				name.setAttribute( "value", "title" );
				name.setAttribute( "class", "rowtitle" );
				name.setAttribute( "width", "100" );
				richlistitem.appendChild( name );
		
				var value = document.createElement( "description" );
				value.setAttribute( "class", "text" );
				value.setAttribute( "flex", "1" );
				var text = document.createTextNode( title.firstChild.nodeValue );
				value.appendChild( text );
				richlistitem.appendChild( value );
								
				var chars = document.createElement( "description" );
				chars.setAttribute( "value", title.firstChild.nodeValue.length );
				chars.setAttribute( "class", "rowvalue" );
				chars.setAttribute( "width", "60" );
				richlistitem.appendChild( chars );
				listbox.appendChild( richlistitem );
				
				noItems = false;
			}
  	}
  	
  	var tags = topWindow._content.document.getElementsByTagName( "meta" );
  	for( var i = 0; i < tags.length; i++ )
		{
			var tag = tags.item( i );
			if( tag.hasAttribute( "name" ) && tag.hasAttribute( "content" ) )
			{
				var richlistitem = document.createElement( "richlistitem" );
				var name = document.createElement( "description" );
				name.setAttribute( "value", tag.getAttribute( "name" ) );
				name.setAttribute( "class", "rowtitle" );
				name.setAttribute( "width", "100" );
				richlistitem.appendChild( name );
		
				var value = document.createElement( "description" );
				value.setAttribute( "class", "text" );
				value.setAttribute( "flex", "1" );
				var text = document.createTextNode( tag.getAttribute( "content" ) );
				value.appendChild( text );
				richlistitem.appendChild( value );
				
				var chars = document.createElement( "description" );
				chars.setAttribute( "value", tag.getAttribute( "content" ).length );
				chars.setAttribute( "class", "rowvalue" );
				chars.setAttribute( "width", "60" );
				richlistitem.appendChild( chars );
				listbox.appendChild( richlistitem );
				
				noItems = false;
			}
		}
		
		if( noItems )
		{
			var content = document.createElement( "description" );
			content.setAttribute( "value", "No meta tags specified on this page." );
			content.setAttribute( "class", "text" );
			
			vbox.appendChild( content );
		}
	},
	
	trim: function( str )
	{
		return str.replace( /^\s*|\s*$/g, "" );
	},
	
  destroy: function()
  {
    
  },
  
  copy: function()
  {
  	var listbox = document.getElementById( "searchstatus-metadata-listbox" );
  	
  	var listitems = listbox.selectedItems;
  	if( listitems == null )
  	{
  		listitems = [listbox.selectedItem];
  	}
  	
  	var copytext = "";

  	for( i = 0; i < listitems.length; i++ )
		{
			var item = listitems[i];
			
			var itemname = item.childNodes.item( 0 ).getAttribute( "value" );
			var itemvalue = item.childNodes.item( 1 ).firstChild.nodeValue;

			if( i != 0 )
			{
				copytext += ( itemname.length > 0 ? "\n" : " " );
			}

			copytext += itemname + ( itemname.length > 0 ? ": " : "" ) + itemvalue;
		}
		
		var str = Components.classes["@mozilla.org/supports-string;1"].createInstance( Components.interfaces.nsISupportsString );
		if( !str )
		{
			return false;
		}
		str.data=copytext;
		
		var trans = Components.classes["@mozilla.org/widget/transferable;1"].createInstance( Components.interfaces.nsITransferable );
		if( !trans )
		{
			return false;
		}
		
		trans.addDataFlavor( "text/unicode" );
		trans.setTransferData( "text/unicode", str, copytext.length * 2 );
		
		var clipid=Components.interfaces.nsIClipboard;
		var clip = Components.classes["@mozilla.org/widget/clipboard;1"].getService( clipid );
		if( !clip )
		{
			return false;
		}
		
		clip.setData( trans, null, clipid.kGlobalClipboard );
		
		return true;
  }
};
  	
function getTopWindow()
{
  var windowManager = Components.classes["@mozilla.org/appshell/window-mediator;1"].getService();
  var windowManagerInterface = windowManager.QueryInterface( Components.interfaces.nsIWindowMediator );
  var topWindow = windowManagerInterface.getMostRecentWindow( "navigator:browser" );
  if( !topWindow )
  {
    topWindow = window.openDialog("chrome://browser/content/browser.xul", "_blank", "chrome,all,dialog=no", "about:blank", null, null);
  }

  return topWindow;
} 

function debugsm( message ) 
{
  var time = new Date();
  var time_string = time.getHours() + ":" + time.getMinutes() + ":" + time.getSeconds();

  dump( "[SearchStatus " + time_string + "]: " + message + "\n" );
}
